<?xml version="1.0" encoding="UTF-8"?>

<!--
    Document      :     HojaEstiloEspanol.xsl
    Created on    :     27 de diciembre de 2011, 17:09
    Author        :     Israel
    Description   :     Purpose of transformation follows.

    Documentation :     http://www.w3schools.com/xsl
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>

    <xsl:template match="/">                                                    <!-- Cuando encuentra la raíz del documento -->
    <html>

    <div style="text-align: center;">
        <H1>AZETA-REM</H1>
        <H2>Herramienta de Gestión de Requisitos</H2>
    </div>

        <xsl:for-each select="//Objeto">

            <!-- INICIO Sección -->
             <xsl:if test=" tipo = 'Seccion' ">
                 <h2>
                    <xsl:value-of select = "numeracion"/>&#160;<xsl:value-of select = "nombre"/>  <!-- Para pintar un espacio en blanco &#160;  -->
                </h2>
                <br></br>

             </xsl:if>
            <!-- FIN Secciòn -->



            <!-- INICIO Apéndices -->
            <xsl:if test=" tipo = 'Apendice' ">                                   <!-- Por cada Apéndice -->
                <h2>
                    <xsl:value-of select = "numeracion"/>&#160;<xsl:value-of select = "nombre"/>
                </h2>
                <br></br>
             </xsl:if>
            <!-- FIN Apéndices -->



            <!-- INICIO Párrafos -->
            <xsl:if test=" tipo = 'Parrafo' ">                                      <!-- Por cada Párrafo -->
                        <xsl:value-of select = "texto"/>
                        <br></br>
            </xsl:if>
            <!-- FIN Párrafos -->



            <!-- INICIO Elementos Glosario -->
            <xsl:if test=" tipo = 'ElementoGlosario' ">                         <!-- Por cada Elemento Glosario -->
                        <b><xsl:value-of select = "nombre"/>:</b>&#160;
                        <xsl:value-of select = "texto"/>
                        <br></br>
            </xsl:if>
            <!-- FIN Elementos Glosario -->



            <!-- INICIO Imágenes -->
            <xsl:if test=" tipo = 'Imagen' ">   <!-- Por cada Imagen -->
                <center><img><xsl:attribute name="src">file:///<xsl:value-of select="rutaImagen"/></xsl:attribute></img><br/>
                    <b>Imagen:&#160;</b><xsl:value-of select="nombre"/></center>
                    <br></br>
            </xsl:if>
            <!-- FIN Imágenes -->


            <!-- INICIO Organizaciones -->
            <xsl:if test=" tipo = 'Organizacion' ">                                   <!-- Por cada Organización -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    Organización
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>&#160;
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Dirección -->
                                <td border="1" align="right" valign="top"><b>Dirección</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "direccion"/>&#160;</td>
                            </tr>

                            <tr>                                                            <!-- Teléfono -->
                                <td border="1" align="right" valign="top"><b>Teléfono</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "telefono"/>&#160;</td>
                            </tr>

                            <tr>                                                            <!-- Fax -->
                                <td border="1" align="right" valign="top"><b>Fax</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "fax"/>&#160;</td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/>&#160;</td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Organizaciones -->



            <!-- INICIO Participantes -->
            <xsl:if test=" tipo = 'Participante' ">                                   <!-- Por cada Participante -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    Participante
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>&#160;
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Organización -->
                                <td border="1" align="right" valign="top"><b>Organización</b></td>
                                <td border="1" valign="top">

                                    <xsl:for-each select=".//Organizacion">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "idenOrg"/>&#160;<xsl:value-of select = "nombreOrg"/>&#160;
                                    </xsl:for-each>

                                </td>
                            </tr>

                            <tr>                                                            <!-- Rol -->
                                <td border="1" align="right" valign="top"><b>Rol</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "rol"/>&#160;</td>
                            </tr>

                            <tr>                                                            <!-- Es desarrollador -->
                                <td border="1" align="right" valign="top"><b>Es desarrollador</b></td>
                                <td border="1" valign="top">
                                    <xsl:if test = "esDesarrollador = 'true'">Sí</xsl:if>
                                    <xsl:if test = "esDesarrollador = 'false'">No</xsl:if>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Es cliente -->
                                <td border="1" align="right" valign="top"><b>Es cliente</b></td>
                                <td border="1" valign="top">
                                    <xsl:if test = "esCliente = 'true'">Sí</xsl:if>
                                    <xsl:if test = "esCliente = 'false'">No</xsl:if>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Es usuario -->
                                <td border="1" align="right" valign="top"><b>Es usuario</b></td>
                                <td border="1" valign="top">
                                    <xsl:if test = "esUsuario = 'true'">Sí</xsl:if>
                                    <xsl:if test = "esUsuario = 'false'">No</xsl:if>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/>&#160;</td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Participantes -->



            <!-- INICIO Reuniones -->
            <xsl:if test=" tipo = 'Reunion' ">                                        <!-- Por cada Reunión -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    Reunión
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Fecha-->
                                <td border="1" align="right" valign="top"><b>Fecha</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "fechaReunion"/></td>
                            </tr>

                            <tr>                                                            <!-- Hora -->
                                <td border="1" align="right" valign="top"><b>Hora</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "horaReunion"/></td>
                            </tr>

                            <tr>                                                            <!-- Lugar -->
                                <td border="1" align="right" valign="top"><b>Lugar</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "lugar"/></td>
                            </tr>

                            <tr>                                                            <!-- Asistentes -->
                                <td border="1" align="right" valign="top"><b>Asistentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Asistentes">                        <!-- Por cada Asistente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Resultados -->
                                <td border="1" align="right" valign="top"><b>Resultados</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "resultados"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Reuniones -->



            <!-- INICIO Objetivos -->
            <xsl:if test=" tipo = 'Objetivo' ">                                      <!-- Por cada Objetivo -->
                       <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    El sistema deberá:<br/>
                                    <blockquote><i><xsl:value-of select = "texto"/><br/></i></blockquote>
                                </td>
                            </tr>
                            
                            <tr>                                                            <!-- SubObjetivos  -->
                                <td border="1" align="right" valign="top"><b>Sub-objetivos</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//SubObjetivo">                            <!-- Por cada SubObjetivo -->
                                        <b>- &#160;[<xsl:value-of select = "identificacion"/>]&#160;<xsl:value-of select = "nombre"/></b>&#160;El sistema deberá:&#160;<xsl:value-of select = "descripcion"/><br/>
                                        <xsl:for-each select=".//SubObjetivo_n2">                            <!-- Por cada SubObjetivo -->
                                            <b>&#160;&#160;&#160;&#160;&#160;&#160;- [<xsl:value-of select = "identificacion"/>]&#160;<xsl:value-of select = "nombre"/></b>&#160;El sistema deberá:&#160;<xsl:value-of select = "descripcion"/><br/>
                                        </xsl:for-each>
                                    </xsl:for-each>
                                </td>
                            </tr>
                            
                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Objetivos -->



            <!-- INICIO Actores -->
            <xsl:if test=" tipo = 'Actor' ">                                         <!-- Por cada Actor -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                          <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    Este actor representa:<br/>
                                    <blockquote><i><xsl:value-of select = "texto"/><br/></i></blockquote>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Actores -->



            <!-- INICIO Requisitos de Información -->
            <xsl:if test=" tipo = 'ReqInformacion' ">                                <!-- Por cada Requisito -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    El sistema deberá:<br/>
                                    <blockquote><i><xsl:value-of select = "conceptoRelevante"/><br/></i></blockquote>
                                </td>
                            </tr>


                            <tr>                                                            <!-- Datos especificos  -->
                                <td border="1" align="right" valign="top"><b>Datos específicos</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//DatoEspecifico">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "descripcion"/>&#160;(<xsl:value-of select = "comentario"/>)<br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Tiempo de vida -->
                                <td border="1" align="right" valign="top"><b>Tiempo<br/>de vida</b></td>
                                <td border="1" valign="top">
                                    Medio: <xsl:value-of select = "valorMedioVida"/> <xsl:value-of select = "unidadTiempoMedioVida"/><br/>
                                    Máximo: <xsl:value-of select = "valorMaxVida"/> <xsl:value-of select = "unidadTiempoMaxVida"/>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Ocurrencias simultáneas -->
                                <td border="1" align="right" valign="top"><b>Ocurrencias<br/>simultáneas</b></td>
                                <td border="1" valign="top">
                                    Medio: <xsl:value-of select = "ocurrenciasMedia"/> veces<br/>
                                    Máximo: <xsl:value-of select = "ocurrenciasMaxima"/> veces
                                </td>
                            </tr>

                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Requisitos de Información -->



            <!-- INICIO Requisitos de Restricción -->
            <xsl:if test=" tipo = 'ReqRestriccion' ">                                <!-- Por cada Requisito -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    La información almacenada por el sistema deberá satisfacer la siguiente restricción:<br/>
                                    <blockquote><i><xsl:value-of select = "descripcion"/><br/></i></blockquote>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Requisitos de Restricción -->



            <!-- INICIO Casos de uso -->
            <xsl:if test=" tipo = 'CasoUso' ">                                      <!-- Por cada Caso de uso -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    El sistema deberá comportarse como se describe en el actual Caso de uso cuando:<br/>
                                    <blockquote><i><xsl:value-of select = "eventoActivacion"/><br/></i></blockquote>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Precondición -->
                                <td border="1" align="right" valign="top"><b>Precondición</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "precondicion"/></td>
                            </tr>

                            <tr>                                                            <!-- Secuencia normal -->
                                <td border="1" align="right" valign="top"><b>Secuencia<br/>normal</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Paso">                             <!-- Por cada Paso -->
                                        <xsl:param name='cont'><xsl:number /></xsl:param>
                                        <xsl:value-of select='$cont'/>. <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Postcondición -->
                                <td border="1" align="right" valign="top"><b>Postcondición</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "postcondicion"/></td>
                            </tr>

                            <tr>                                                            <!-- Excepciones -->
                                <td border="1" align="right" valign="top"><b>Excepciones</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Excepcion">                        <!-- Por cada Excepción -->
                                        <xsl:param name='contExc'><xsl:number /></xsl:param>
                                        <xsl:value-of select='$contExc'/>. <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Frecuencia -->
                                <td border="1" align="right" valign="top"><b>Frecuencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "veces"/> veces por <xsl:value-of select = "unidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Casos de uso -->



            <!-- INICIO Requisitos Funcionales -->
            <xsl:if test=" tipo = 'ReqFuncional' ">                               <!-- Por cada Requisito -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    El sistema deberá:<br/>
                                    <blockquote><i><xsl:value-of select = "texto"/><br/></i></blockquote>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Requisitos Funcionales -->



            <!-- INICIO Requisitos No Funcionales -->
            <xsl:if test=" tipo = 'ReqNoFuncional' ">                               <!-- Por cada Requisito -->
                        <table width="100%" cellspacing="-1" style="border: 2px solid #151515">
                            <tr>                                                            <!-- Cabecera -->
                                <td width="12%" border="1" bgcolor="D0EB97" align="right" valign="top"><b>
                                    <xsl:value-of select = "identificacion"/>
                                </b></td>
                                <td border="1" bgcolor="D0EB97" valign="top"><b>
                                    <xsl:value-of select = "nombre"/>
                                </b></td>
                            </tr>

                            <tr>                                                            <!-- Versión y Fecha-->
                                <td border="1" align="right" valign="top"><b>Versión</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "version"/> (<xsl:value-of select = "fecha"/>)</td>
                            </tr>

                            <tr>                                                            <!-- Autores -->
                                <td border="1" align="right" valign="top"><b>Autores</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Autor">                            <!-- Por cada Autor -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Fuentes -->
                                <td border="1" align="right" valign="top"><b>Fuentes</b></td>
                                <td border="1" valign="top">
                                    <xsl:for-each select=".//Fuente">                           <!-- Por cada Fuente -->
                                        <xsl:value-of select = "nombre"/><br/>
                                    </xsl:for-each>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Descripción -->
                                <td border="1" align="right" valign="top"><b>Descripción</b></td>
                                <td border="1" valign="top">
                                    El sistema deberá:<br/>
                                    <blockquote><i><xsl:value-of select = "texto"/><br/></i></blockquote>
                                </td>
                            </tr>

                            <tr>                                                            <!-- Importancia -->
                                <td border="1" align="right" valign="top"><b>Importancia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "importancia"/></td>
                            </tr>

                            <tr>                                                            <!-- Urgencia -->
                                <td border="1" align="right" valign="top"><b>Urgencia</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "urgencia"/></td>
                            </tr>

                            <tr>                                                            <!-- Estado -->
                                <td border="1" align="right" valign="top"><b>Estado</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estadoDesarrollo"/></td>
                            </tr>

                            <tr>                                                            <!-- Estabilidad -->
                                <td border="1" align="right" valign="top"><b>Estabilidad</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "estabilidad"/></td>
                            </tr>

                            <tr>                                                            <!-- Comentarios -->
                                <td border="1" align="right" valign="top"><b>Comentarios</b></td>
                                <td border="1" valign="top"><xsl:value-of select = "comentario"/></td>
                            </tr>
                        </table>
                        <br></br>
            </xsl:if>
            <!-- FIN Requisitos No Funcionales -->



            <!-- INICIO Matrices de Rastreabilidad -->
            <xsl:if test=" tipo = 'MatrizRastreabilidad' ">                          <!-- Por cada Matriz de Rastreabilidad -->
                        SIN DESARROLLAR
                        <br></br>
            </xsl:if>
            <!-- FIN Matrices de Rastreabilidad -->
          </xsl:for-each>
    </html>
    </xsl:template>

</xsl:stylesheet>
